Class MaturityLevel
	Public ID
	Public Description
	
	Private Sub Class_Initialize() : Clear : End Sub
	Private Sub Clear() : ID=0 : Description = "Unknown / Not Set" : End Sub
	Private Sub SetProperties(a,b) : ID = a : Description = b : End Sub
	
	Public Function ToString() : ToString = ID & " - " & Description : End Function
	Public Sub Load(MaturityLevelID)
		Clear
		Select Case MaturityLevelID
			Case 1 : SetProperties 1,"appropriate for all ages"
			Case 2 : SetProperties 2,"choking hazard for children under 4"
			Case 3 : SetProperties 3,"must be at least this tall to play"
			Case 4 : SetProperties 4,"need to be accompanied by an adult"
			Case 5 : SetProperties 5,"aren't you a little to old to be trick or treating"
			Case 6 : SetProperties 6,"I'll need to see some identification"
			Case 7 : SetProperties 7,"anything goes"
		End Select
	End Sub
End Class

Function LoadAllMaturityLevels
	Dim i,MaturityLevels(6)
	For i = 0 To UBound(MaturityLevels)
		Set MaturityLevels(i) = New MaturityLevel
		MaturityLevels(i).Load(i+1)
	Next
	LoadAllMaturityLevels = MaturityLevels
End Function

Function WriteMaturityLevelOptions(selected)
	Dim MaturityLevels : MaturityLevels = LoadAllMaturityLevels
	Dim i : For i = 0 To UBound(MaturityLevels)
		Response.Write "<option value=""" & MaturityLevels(i).ID & """"
		If MaturityLevels(i).ID = selected Then Response.Write " selected=""true"""
		Response.Write ">" & MaturityLevels(i).ToString & "</option>"
	Next
End Function