<% option explicit %>
<!-- #include file="../Includes/Request_Start.inc.asp" -->
<script runat="server" language="vbscript" src="/Includes/logger.vbs"></script>
<script runat="server" language="vbscript" src="/Includes/helperFunctions.vbs"></script>
<script runat="server" language="vbscript" src="/Includes/userRoles.vbs"></script><%

If Not IsInRole("Site Administrator") Then  Response.Redirect("/")

Dim GameID : GameID = Request("GameId")

If Len(Request.Form("cancel")) Then
	Response.Redirect "gamePopUp.asp?" & GameId
		
ElseIf Len(Request.Form("publish"))>0 Then
	With Server.CreateObject("ADODB.Command")
		.ActiveConnection = Application("ConnectionString")
		.CommandText = "UPDATE [Games] SET [Date Published] = COALESCE([Date Published],GETDATE()) WHERE [Game Id]=?"
		.Parameters.Append .CreateParameter("Game Id", adInteger, adParamInput, 4, GameID)
		.Execute
	End With
	With New Logger : .AdminGame(GameID) : End With
	Response.Redirect "gamePopUp.asp?" & GameId

ElseIf Len(Request.Form("unpublish"))>0 Then
	With Server.CreateObject("ADODB.Command")
		.ActiveConnection = Application("ConnectionString")
		.CommandText = "UPDATE [Games] SET [Date Published] = NULL, [Date Category Featured] = NULL WHERE [Game Id]=?"
		.Parameters.Append .CreateParameter("Game Id", adInteger, adParamInput, 4, GameID)
		.Execute
	End With
	With New Logger : .AdminGame(GameID) : End With
	Response.Redirect "gamePopUp.asp?" & GameId	
End If


Dim Title, DatePublished
With Server.CreateObject("ADODB.Command")
	.ActiveConnection = Application("ConnectionString")
	.CommandText = _
		"SELECT [Title], [Date Published] " & _
		"  FROM [Games] " & _
		" WHERE [Game Id] = ?"
	.Parameters.Append .CreateParameter("Game Id", adInteger, adParamInput, 4, GameID)
	With .Execute
		If .EOF Then : Response.Write "Invalid GameId" : Response.End : End If
		Title = .Fields("Title")
		DatePublished = .Fields("Date Published")
	End With
End With
%>
<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Publish Game</title>
<link href="../Includes/styles.css" rel="stylesheet" type="text/css" />
</head>
<body style="margin:5px; ">
<form method="post">

<% If IsNull(DatePublished) Then %>
  <h1>Publish Game</h1>
<% Else %>
  <h1>Unpublish Game</h1>
<% End If %>

<h2 style="margin-top:10px;">Game Title</h2><%=Title%>

<p style="margin-top:10px;">
<% If IsNull(DatePublished) Then %>
	<input name="publish" type="submit" value="Publish Game" onClick="return (confirm('Are you sure you want to publish?'))" />
<% Else %>
	<input name="unpublish" type="submit" value="Unpublish Game" onClick="return (confirm('Are you sure you want to unpublish?'))" />
<% End If %>	
	&nbsp;
    <input name="cancel" type="submit" value="Cancel"/></td>
</p>
</form>
</body>
</html>