<% Option Explicit %>
<!-- #include file="../../Includes/Request_Start.inc.asp" -->
<script runat="server" language="vbscript" src="../../Includes/gameValidator.vbs"></script>
<%

Dim ChangeTypes : ChangeTypes = Array ("Addition", "Subtraction", "Multiplication", "Division","Percentage", "Reset")

Dim GameID, LinkId
GameID = CLng(Request.QueryString("GameId"))
LinkId = CLng(Request.QueryString("LinkId"))

Dim Conn : Set Conn = Server.CreateObject("ADODB.Connection")
 Conn.Open Application("ConnectionString")
ValidateGameWithConn GameID, Conn

Dim variableLevel
With Server.CreateObject("ADODB.Command")
	.ActiveConnection = Application("ConnectionSTring")
	.CommandText = "ChooseYourStory.dbo.Story_Editing_GetEditorOptions"
	.CommandType = adCmdStoredProc
	.Parameters.Append .CreateParameter("@StoryId",adInteger,adParamInput,4,GameId)
	.Parameters.Append .CreateParameter("@User_Username",adVarChar,adParamInput,30,Session("Username"))
	With .Execute
		variableLevel = .Fields("Variable_Level")
	End With
End With

If Not IsEmpty(Request.Form("_save")) Then Save

Sub Save
	Dim El
	With Server.CreateObject("ADODB.Command")
		.ActiveConnection = Conn
		.CommandText = "DELETE FROM [Game Link Variable Changes] WHERE [Game Id] = ? AND [Link Id] = ?"
		.Parameters.Append .CreateParameter("GameID",adInteger,adParamInput,4,GameID)
		.Parameters.Append .CreateParameter("LinkId",adInteger,adParamInput,4,LinkId)
		.Execute
	End With

	With Server.CreateObject("ADODB.Command")
		.ActiveConnection = Conn
		.CommandText = _
			"INSERT INTO [Game Link Variable Changes] ([Game ID], [Link Id], [Variable], [Change], [Count Multiple], [Change Type], [Random Range]) " & _
			"VALUES (?, ?, ?, ?, ?, ?, ?) "
		.Parameters.Append .CreateParameter("GameID",adInteger,adParamInput,4,GameID)
		.Parameters.Append .CreateParameter("LinkId",adInteger,adParamInput,4,LinkId)
		.Parameters.Append .CreateParameter("Variable",adVarChar,adParamInput,10)
		.Parameters.Append .CreateParameter("Change",adInteger,adParamInput,4)
		.Parameters.Append .CreateParameter("Count Multiple",adInteger,adParamInput,4)
		.Parameters.Append .CreateParameter("Change Type",adVarChar,adParamInput,15)
		.Parameters.Append .CreateParameter("Random Range",adInteger,adParamInput,4)
		For Each El In Request.Form
			If (InStr(El,"_")  = 0) And (Request.Form(El)<>"None") Then

				Dim Variable, ChangeType, Change, CountMultiple
				Variable = El
				ChangeType = Request.Form(El)
				Change = Split( Request.Form(El & "_Change"), "D" )
				CountMultiple = Not IsEmpty(Request.Form(El & "_ChangeMultiple"))

				If (ChangeType = "Basic") Then
					'Could happen if VARIABLENAME_Change is empty
					If UBound(Change) = -1 Then Change = Array(0)

					'Handle negatives
					If Left(Change(0),1) = "-" Then
						ChangeType = "Subtraction"
						Change(0) = Abs(Int(Change(0)))
					Else
						ChangeType = "Addition"
					End If
				End If

				If (ChangeType = "Reset") Or ( Int(Change(0)) <> 0 ) Then

					.Parameters("Variable").Value = Variable
					.Parameters("Count Multiple").Value = CountMultiple
					.Parameters("Change Type").Value = ChangeType
					.Parameters("Change").Value = Int(Change(0))
					If UBound(Change) = 1 Then
						.Parameters("Random Range").Value = Int(Change(1))
					Else
						.Parameters("Random Range").Value = 1
					End If

					.Execute
				End If

			End If
		Next
	End With

	Conn.Close
	%><script>
	    var win = ( (window.dialogArguments) ? (window.dialogArguments) : (window.opener) );
		win.btn_save_changes.click();
	    window.close();
	  </script><%
	Response.End
End Sub

    %>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
"http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
    <title>Variable Changes</title>
    <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
    <link href="../../App_Themes/CYS/styles.css" rel="stylesheet" type="text/css">
    <base target="MAG_editVariableChanges">
    <script language="javascript">

        window.name = "MAG_editVariableChanges";

        function validate(frm) {
            for (var i = 0; i < frm.elements.length; i++) {
		<% If variableLevel = "Advanced" Then %>
			if (frm.elements[i].type == 'select-one') {
                    if (!validateSelection(frm.elements[i])) return false;
                }
		<% Else %>
			if (frm.elements[i].type == 'hidden' && frm.elements[i].name.indexOf('_') != 0) {
                    if (!validateSelection2(frm, frm.elements[i].name)) return false;
                }
		<% End If %>
	}
            frm.submit();
        }
        function validateSelection2(frm, varName) {
            var varEl = frm.elements[varName + '_Change'];
            varEl.value = varEl.value.toUpperCase();
            var change = varEl.value;
            if (change == '') return true;

            var changeInvalidMsg =
                'Additions must be in normal whole-number form (1, 24, 225, etc) \n' +
                'or random form (xDy):\n' +
                ' x - number of dice to roll (max 99)\n' +
                ' y - number of sides on the die\n\n' +
                'For example, 3d6 would roll three six-sided\n' +
                'dice, add them up, and add the results to \nthe variable.\n\n' +
                'Note: Additions may be prefixed with "-" to\n' +
                'indicate a negative change (aka Subtraction).';

            //ensure valid format
            if (change.indexOf('D') == -1) {
                if (isNaN(parseInt(change))) {
                    alert(changeInvalidMsg);
                    return false;
                }
                else {
                    varEl.value = parseInt(change);
                }
            }
            else {
                if (change.indexOf("-") == 0) change = change.substr(1);
                if (!(/^[0-9]{1,2}D[1-9][0-9]{0,5}$/.exec(change))) {
                    alert(changeInvalidMsg);
                    return false;
                }
            }

            return true;
        }

        function validateSelection(sel) {

            if (sel.options[sel.selectedIndex].value == 'None') return true;

            if (sel.form.elements[sel.name + '_Change'].value == '') {
                alert('If you selected a Change Type, you must enter a value for the change.');
                return false;
            }

            //clean input
            var change = sel.form.elements[sel.name + '_Change'].value.toUpperCase();
            sel.form.elements[sel.name + '_Change'].value = change;

            var changeInvalidMsg =
                'Changes must be in normal whole-number form (1, 24, 225, etc) \n' +
                'or random form (xDy):\n' +
                ' x - number of dice to roll (max 99)\n' +
                ' y - number of sides on the die\n\n' +
                'For example, 3d6 would roll three six-sided\n' +
                'dice, add them up, and change the variable with\n ' +
                'the result.\n';

            //ensure valid format
            if (change.indexOf('D') == -1) {
                if (isNaN(parseInt(change))) {
                    alert(changeInvalidMsg);
                    return false;
                }
            }
            else {
                if (!(/^[0-9]{1,2}D[1-9][0-9]{0,5}$/.exec(change))) {
                    alert(changeInvalidMsg);
                    return false;
                }
            }

            return true;
        }

        function selectChangeType(sel) {
            if (sel.options[sel.selectedIndex].value == 'None') {
                sel.form.elements[sel.name + '_Change'].value = '';
                sel.form.elements[sel.name + '_Change'].disabled = true;
                sel.form.elements[sel.name + '_Change'].style.backgroundColor = 'DFDFDF';

                sel.form.elements[sel.name + '_ChangeMultiple'].checked = false;
                sel.form.elements[sel.name + '_ChangeMultiple'].disabled = true;
            }
            else {
                sel.form.elements[sel.name + '_Change'].disabled = false;
                sel.form.elements[sel.name + '_Change'].style.backgroundColor = 'FFFFFF';
                sel.form.elements[sel.name + '_ChangeMultiple'].disabled = false;
            }
        }
    </script>
</head>
<body>
    <form target="MAG_editVariableChanges" method="post">
        <div style="padding: 15px;">
            <h1>Variable Changes</h1>
            <% If variableLevel="Advanced" Then %>
            <p class="smallerText">
                Enter how each variable will change (if any) and
   whether or not the change should count each time or only
   the first time the link is clicked. The change can be a
   regular number or a <a target="_blank" href="/help/articles/article.aspx?ArticleId=14">random range</a>.
            </p>
            <% Else %>
            <p class="smallerText">
                The following additions will occur when the link is clicked. When Count Multiple is unchecked, the
 addition will occur only the first time the link is clicked.

                <br />
                Hint: use a negative number to subtract.
            </p>
            <% End If %>
            <table border="0" cellspacing="6" cellpadding="0">
                <% If variableLevel="Advanced" Then %>
                <tr>
                    <th>Variable</th>
                    <th>Change Type</th>
                    <th>Change</th>
                    <th>Count Multiple</th>
                </tr>
                <% End If %>
                <%
	With Server.CreateObject("ADODB.Command")
		.ActiveConnection = Conn
		.CommandText = _
			"SELECT V.[Variable], " & _
			"       VC.[Change Type], " & _
			"       VC.[Random Range], " & _
			"       VC.[Change], " & _
			"       VC.[Count Multiple] " & _
			"  FROM [Game Variables] V " & _
			"       LEFT JOIN [Game Link Variable Changes] VC " & _
			"               ON V.[GAme Id] = VC.[Game Id] " & _
			"              AND V.[Variable] = VC.[Variable] " & _
			"              AND VC.[Link Id] = ? " & _
			" WHERE V.[Game Id] = ? " & _
			" ORDER BY V.[Variable] "
		.Parameters.Append .CreateParameter("LinkId",adInteger,adParamInput,4,LinkId)
		.Parameters.Append .CreateParameter("GameID",adInteger,adParamInput,4,GameID)
		With .Execute
			Do While Not .EOF
				Response.Write "<tr>"

				If variableLevel="Advanced" Then
					Response.Write "<td><strong>" & .Fields("Variable") & "</strong></td>"

					Response.Write "<td><select name=""" & .Fields("Variable") & """ onchange=""selectChangeType(this);"">"
					Response.Write "<option value=""None"">None</option>"
					Dim i : For i = 0 To UBound(ChangeTypes)
						Response.Write "<option value=""" & ChangeTypes(i) & """"
						If ChangeTypes(i) = .Fields("Change Type") Then Response.Write " selected"
						Response.Write ">" & ChangeTypes(i) & "</option>"
					Next
					Response.Write "</select></td>"

					Response.Write "<td><input maxlength=""7"" size=""5"" type=""text"""
					If IsNull(.Fields("Change Type")) Then Response.Write " disabled=""disabled"" style=""background-color:#DFDFDF"""
					Response.Write " name=""" & .Fields("Variable") & "_Change""" & _
									" value=""" & .Fields("Change")
					If .Fields("Random Range")>1 Then Response.Write "D" & .Fields("Random Range")
					Response.Write """></td>"

					Response.Write "<td align=""center""><input type=""checkbox"""
					If IsNull(.Fields("Change Type")) Then Response.Write " disabled=""disabled"""
					Response.Write " name=""" & .Fields("Variable") & "_ChangeMultiple"""
					If .Fields("Count Multiple") Then Response.Write " checked=""true"""
					Response.Write " value=""1""></td>"
				Else

					Response.Write "<td class=""smallerText"">"
					Response.Write "Add"
					Response.Write "<input type=""hidden"" name=""" & .Fields("Variable") & """ value=""Basic"">"
					Response.Write "</td>"

					Response.Write "<td>"
					Response.Write "<input maxlength=""7"" size=""5"" type=""text"""
					Response.Write " name=""" & .Fields("Variable") & "_Change"""
					Response.Write " value="""
					If .Fields("Change Type")="Subtraction" Then Response.Write "-"
					Response.Write .Fields("Change")
					If .Fields("Random Range")>1 Then Response.Write "D" & .Fields("Random Range")
					Response.Write """>"
					Response.Write "</td>"

					Response.Write "<td><span class=""smallerText"">to</span> <strong>" & .Fields("Variable") & "</strong>"
					Response.Write "<span class=""smallerText"">, and "
					Response.Write "<input type=""checkbox"""
					Response.Write " name=""" & .Fields("Variable") & "_ChangeMultiple"""
					If .Fields("Count Multiple") Then Response.Write " checked=""true"""
					Response.Write " value=""1"">"
					Response.Write " count multiple times.</td>"

				End If

				Response.Write "</tr>"
				.MoveNext
			Loop
		End With
	End With
%>
            </table>
            <p>
                <input type="button" value=" Save Changes & Close " class="smallerText" onclick="validate(this.form);">
            </p>
            <input type="hidden" name="_save" value="_save" />
            <% If variableLevel="Basic" Then %>
            <p class="smallerText">
                Need more options? Change your <em>Variable Level</em> to <em>Advanced</em> on the Storygame Properties page.
            </p>
            <% End If %>
        </div>
    </form>
</body>
</html>
<% Conn.Close %>