<% Option Explicit %>
<!-- #include file="../../../Includes/Request_Start.inc.asp" -->
<script runat="server" language="vbscript" src="../../../Includes/sessionValidator.vbs"></script>
<script runat="server" language="vbscript" src="../../../Includes/ClientMessages.vbs"></script>
<script runat="server" language="vbscript" src="../duel.vbs"></script>
<%

ValidateSession

Dim DuelId
DuelId = Clng(Request.QueryString("DuelId"))

Dim Target
Target = Request.QueryString("target")
If Target="" Then Target = Request.Form("Target")
If Target="" Then Target = "."

Dim myDuel : Set myDuel = New Duel
If Not myDuel.Load(DuelId) Then Response.Redirect Target

%>
<h2><%=myDuel.DuelType%> Duel</h2>
<%


Function Cardnalize(num)
	Cardnalize = num
	Select Case CStr(Right(num,1))
		Case "1" : Cardnalize = Cardnalize & "st"
		Case "2" : Cardnalize = Cardnalize & "nd"
		Case "3" : Cardnalize = Cardnalize & "rd"		
		Case Else : Cardnalize = Cardnalize & "th"		
	End Select
End Function
Dim IsChallenger : IsChallenger = myDuel.ChallengerUsername = Session("Username")
Dim IsChallengee : IsChallengee = myDuel.ChallengeeUsername = Session("Username")

Dim Challenger, Challengee, ChallengerProper, ChallengeeProper
If IsChallenger Then Challenger = "you" Else Challenger = myDuel.ChallengerUsername
If IsChallengee Then Challengee = "you" Else Challengee = myDuel.ChallengeeUsername
ChallengerProper = UCase(Left(Challenger, 1)) & Mid(Challenger, 2)
ChallengeeProper = UCase(Left(Challengee, 1)) & Mid(Challengee, 2)


Dim Points
If myDuel.Wager > 1 Then Points = myDuel.Wager & " points" Else Points = myDuel.Wager & " point"
%>
<p><%=ChallengeeProper%> can remember <%=MonthName(Month(myDuel.DuelDate))%>&nbsp;<%=Cardnalize(DatePart("d",myDuel.DuelDate))%>, 
 <%=DatePart("yyyy",myDuel.DuelDate)%> like it was yesterday. <%=ChallengerProper%> scared the absolute bee-jeebies out of
 <%=Challengee%> by shouting "I challenge you to a duel in the ancient tradition of Toggle!"</p>

<% If myDuel.Status = "Open" Then %>
  <% If IsChallengee  Then %>
    <p>After gathering your composure, you had a tough choice to make. If you were able to guess whether or not
	<%=Challenger%> checked a box, you would walk away with <%=Points%>. But if you guessed incorrectly, you would lose
	as many points.How did you respond?
	</p>
    <ul>
	  <li><a href="toggle/acceptDuel.aspx?<%=Request.QueryString()%>"><%=ChallengerProper%>, I Can Guess What You Picked Any Day!</a></li>
	  <li><a href="decline.asp?<%=Request.QueryString()%>" onClick="return (confirm('Are you sure you want to turn down the duel?'))">I humbly decline your challenge</a></li>
	</ul>

  <% Else %>	
	<p><%=ChallengeeProper%> has not yet accepted the challenge, but the wager is 
	high. <%=myDuel.Wager%> point<%If myDuel.Wager>1 Then Response.Write "s " Else Response.Write " "%> 
	will change hands at the completion of this duel. That is, if <%=myDuel.ChallengeeUsername%> 
	chooses to accept. Stay tuned as more events unfold.
	</p>
	<p><input type="button" onClick="location=this.form.Target.value" value="Go Back"/></p>
  <% End If %>
<% ElseIf myDuel.Status="Declined" Then %>
	<p>However, <%=Challengee%> stood firm and declined the challenge. Perhaps the 
	wager of <%=myDuel.Wager%> point<%If myDuel.Wager>1 Then Response.Write "s " Else Response.Write " "%> 
	was too high or maybe <% If Challengee="you" Then Response.Write "you were" Else Response.Write Challengee + " was"%> just not sure of what <%=Challenger%> would choose. For whatever reason,
	no duel took place on that day.
	</p>
	<p><input type="button" onClick="location=this.form.Target.value" value="Go Back"/></p>

<% ElseIf myDuel.Status="Complete" Then %>	
    <p><%=ChallengeeProper%> confidently accepted the challenge. After thinking for a few seconds, 
	<%=ChallengeeProper%> had figured out what <%=ChallengerProper%> chose and declared, "ha! You have left
	the box <%=myDuel.ChallengeeChoice%>!".</p>
	<p>
	<% If myDuel.Winner="Challenger" Then %>
	  <%=ChallengerProper%> just smiled, revealing the true choice: <%=myDuel.ChallengerChoice%>. <%=ChallengeeProper%> lost the match
	  and gave up <%=Points%>.
	<% ElseIf myDuel.Winner="Challengee" Then %>
	  <%=ChallengerProper%> did a good job staying calm, knowing that <%=Challengee%> guessed the true state of the box.  
	  <em>Oh well,</em> <%=Challenger%> thought, <em>it was only a loss of <%=Points%></em>.
	<% End If %>
	</p>
	<p>
	  <input type="button" onClick="location=this.form.Target.value" value="Go Back"/>
	  <% If myDuel.ChallengerUsername = Session("Username") Then %>
	    &nbsp;&nbsp;
	    <input type="button" onclick="location='selectDuel.aspx?Username=<%=Server.URLEncode(Challengee)%>'" value="Challenge <%=Challengee%> To A Duel"/>	    
	  <% ElseIf myDuel.ChallengeeUsername = Session("Username") Then %>	
	    &nbsp;&nbsp;	  
	    <input type="button" onclick="location='selectDuel.aspx?Username=<%=Server.URLEncode(Challenger)%>'" value="Challenge <%=Challenger%> To A Duel"/>	    
	  <% End If %>
	</p>
	
<% End If %>
<input type="hidden" name="Target" value="<%=Server.HTMLEncode(Target)%>">