<% option explicit  %>
<!-- #include file="../../Includes/Request_Start.inc.asp" -->
<script runat="server" language="vbscript" src="../../Includes/fckeditor.vbs"></script>
<script runat="server" language="vbscript" src="../../Includes/gameValidator.vbs"></script>
<script runat="server" language="vbscript" src="../../Includes/difficultyLevels.vbs"></script>
<script runat="server" language="vbscript" src="../../Includes/categories.vbs"></script>
<script runat="server" language="vbscript" src="../../Includes/maturityLevels.vbs"></script>
<script runat="server" language="vbscript" src="../../Includes/CheckHeader.vbs"></script>
<%CheckHeader "editInfo.aspx"

Dim GameId: GameId = Request.QueryString()
ValidateGame GameId

If Not IsEmpty(Request.Form("next")) Then Save
Sub Save
	If Request.Form("Maturity Level Id")="" Or Request.Form("Category Id")="" Or Request.Form("Difficulty Level Id")="" _
				Or Request.Form("Title")="" Or Request.Form("Description")="" Then
		Response.Write "<script defer>"
		Response.Write "alert('Whoops! All the fields on this page are required!');"
		Response.Write "</script>"
		Exit Sub
	End If
	
	With Server.CreateObject("ADODB.Command")
		.ActiveConnection = Application("ConnectionString")
		.CommandText = _
			"UPDATE [Games] " & _
			"   SET [Title] = P.[Title], [Description] = P.[Description], " & _
			"       [Maturity Level Id] = P.[Maturity Level Id], " & _
			"       [Category Id] = P.[Category Id], [Difficulty Level Id] = P.[Difficulty Level Id] " & _
			"  FROM [Games] G " & _
			"       INNER JOIN (SELECT ? AS [Game Id], ? AS [Title], ? AS [Description], " & _
			"                         ? AS [Maturity Level Id], ? AS [Category Id], ? AS [Difficulty Level Id]) P " & _
			"               ON G.[Game Id] = P.[Game Id] " & _
			"              AND NOT EXISTS (SELECT * FROM [Games] WHERE [Game Id] <> P.[Game Id] " & _
			"                              AND [Title] = P.[Title])"
		.Parameters.Append .CreateParameter("GameID",adInteger,adParamInput,4,GameId)
 	    .Parameters.Append .CreateParameter("Title",200,1,250,Request.Form("Title"))
		.Parameters.Append .CreateParameter("Description",201,1,2147483647,Request.Form("Description"))
		.Parameters.Append .CreateParameter("Maturity Level Id",adInteger,adParamInput,4,Request.Form("Maturity Level Id"))
		.Parameters.Append .CreateParameter("Category Id",adInteger,adParamInput,4,Request.Form("Category Id"))
		.Parameters.Append .CreateParameter("Difficulty Level Id",adInteger,adParamInput,4,Request.Form("Difficulty Level Id"))
		Dim RowsAffected
		.Execute RowsAffected
	End With
	
	If RowsAffected = 0 Then
		Response.Write "<script defer>"
		Response.Write "alert('Whoops! That Title is already in use by another game. Try again!');"
		Response.Write "</script>"
	Else
		Response.Redirect "editTags.aspx?" & GameID
	End If 
End Sub

Dim Title, Description, MaturityLevelId, CategoryId, DifficultyLevelId
With Server.CreateObject("ADODB.Command")
	.ActiveConnection = Application("ConnectionString")
	.CommandText = "SELECT [Title], [Description], [Maturity Level Id], [Category Id], [Difficulty Level Id] FROM [Games] WHERE [Game Id]=?"
	.Parameters.Append .CreateParameter("GameID",adInteger,adParamInput,4,GameId)
	With .Execute
		Title = .Fields("Title")
		Description = .Fields("Description")
		MaturityLevelId = .Fields("Maturity Level Id")
		CategoryId = .Fields("Category Id")
		DifficultyLevelId = .Fields("Difficulty Level Id")
	End With
End With
%>


<form method="post"><div id="mainContent" id="mainContent">

        <h1 style="margin-bottom:10px;"><a href="../">My Stuff</a> &raquo; <a href="../games.aspx">Games</a> &raquo; Publish Game</h1>
<h2>Game Options</h2>
<p>You'll want to make sure that the title and description will give readers
  a good idea of what your game is about before they step in and play it. Also,
  make sure to pick the appropriate categories that your game belongs in.</p>
<div style="margin-top:15px; ">
  <label>Title</label><br/>
  <input type="text" name="Title" maxlength="100" size="75" value="<%=Server.HTMLEncode(Title)%>">
</div>
<div style="margin-top:15px; ">
  <label>Description</label><br/>
	<%  
		With (New FCKeditor)
			.Width = "90%"
			.Value = Description
			.Create "Description"
		End With
	%>
</div>

<div style="margin-top:15px; ">
		<label>Category</label><br/>
		<select name="Category ID" onChange="dataChanged=true;">
		  <option value=""></option>
 		  <%WriteCategoryOptions(CategoryID)%>
		</select><br/>
		<br/>
		<label>Maturity Level</label><br/>
		<select name="Maturity Level Id" onChange="dataChanged=true;">
		  <option value=""></option>
 		  <%WriteMaturityLevelOptions(MaturityLevelId)%>
		</select><br/>
		<br/>
		<label>Difficulty Level</label><br/>
		<select name="Difficulty Level Id" onChange="dataChanged=true;">
		  <option value=""></option>
 		  <%WriteDifficultiesOptions(DifficultyLevelID)%>
		</select><br/>

</div>

<div style="margin-top:15px; ">
<input type="button" onClick="location='../'" value="Cancel"/>
&nbsp;
<input type="button" onClick="location='gameinfo.aspx?<%=GameId%>'" value="&laquo; Previous"/>
&nbsp;
<input type="submit" name="next" value="Next &raquo;"/>
</div>

</div></form>
<% Server.Execute(Application("SiteRoot") & "Includes/footer.asp") %>
