<%@ Page Language="C#" AutoEventWireup="true" Title="Game" %>
<%@ Register TagPrefix="cys" 
    Namespace="ChooseYourStory.Web.Controls"
    Assembly="ChooseYourStory" %>
<%@ Import Namespace="ChooseYourStory.Utilities" %>    
<script runat="server">
    protected override void OnInit(EventArgs e)
    {
        string urlSafeLowercaseTitle = ChooseYourStory.WebApplication.Util.Formatting.UrlPathEncode(
            UrlEncoding.Decode(
                Request.RawUrl.Substring(7, Request.RawUrl.Length - 12) // Everything between /story/ and .aspx
            ).ToLower());

        Response.RedirectPermanent("/story/" + urlSafeLowercaseTitle);
    }
    
    private void Page_PreRender()
    {
        Page.Title = UrlEncoding.Decode(Request.QueryString["Story_Title"]);
    }
</script>
<asp:Content ContentPlaceHolderID="MainContentPlaceHolder" Runat="Server">
    <cys:AspPage ID="MyAspPage" runat="server"
        CopyForm="true" CopyQueryString="false" />
</asp:Content>